# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2
from ..core.unchecked_base_model import UncheckedBaseModel
from .custom_endpointing_model_smart_endpointing_plan_provider import CustomEndpointingModelSmartEndpointingPlanProvider
from .server import Server


class CustomEndpointingModelSmartEndpointingPlan(UncheckedBaseModel):
    provider: CustomEndpointingModelSmartEndpointingPlanProvider = pydantic.Field()
    """
    This is the provider for the smart endpointing plan. Use `custom-endpointing-model` for custom endpointing providers that are not natively supported.
    """

    server: typing.Optional[Server] = pydantic.Field(default=None)
    """
    This is where the endpointing request will be sent. If not provided, will be sent to `assistant.server`. If that does not exist either, will be sent to `org.server`.
    
    Request Example:
    
    POST https://{server.url}
    Content-Type: application/json
    
    {
      "message": {
        "type": "call.endpointing.request",
        "messages": [
          {
            "role": "user",
            "message": "Hello, how are you?",
            "time": 1234567890,
            "secondsFromStart": 0
          }
        ],
        ...other metadata about the call...
      }
    }
    
    Response Expected:
    {
      "timeoutSeconds": 0.5
    }
    
    The timeout is the number of seconds to wait before considering the user's speech as finished. The endpointing timeout is automatically reset each time a new transcript is received (and another `call.endpointing.request` is sent).
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
